////////////////////////////////////////////////////////////////////////////////
// Filename: Input_Atom.cc                                                    //
// Purpose.: defines the class 'Input_Atom'                                   //
////////////////////////////////////////////////////////////////////////////////
// Author: Markus Keidl                                                       //
// Theme.: 2                                                                  //
// Group.: 5 (Gerald Anleitner, Stefan Seltzsam, Markus Keidl                 //
//                                                                            //
// Date of Creation: 20.05.1996        Date of last change: 13.07.1996        //
////////////////////////////////////////////////////////////////////////////////

#include <String.h>
#include "Input_Atom.hh"

// default-constructor
Input_Atom::Input_Atom() : input_atom("") {}

// copy-constructor
Input_Atom::Input_Atom(const Input_Atom& rhs) : input_atom(rhs.input_atom) {};

// init-constructor
Input_Atom::Input_Atom(const String& atom) : input_atom(atom) {};

// destructor, no special code necessary
Input_Atom::~Input_Atom() {};

Input_Atom& Input_Atom::operator=(const Input_Atom& rhs)
{
  input_atom = rhs.input_atom;
  return *this;
}

// comparison operator
int Input_Atom::operator==(const Input_Atom& rhs)
{
  return (input_atom == rhs.input_atom);
}

void Input_Atom::set_Input_Atom(const String& atom)
{
  input_atom = atom;
}

String& Input_Atom::get_Input_Atom()
{
  return input_atom;
}

ostream& operator<<(ostream& s, Input_Atom atom)
{
  s << atom.input_atom;
  return s;
}


