////////////////////////////////////////////////////////////////////////////////
// Filename: labelled_transition.hh                                           //
// Purpose : Definition of class Unlabelled_Transition                        //
//           A class that provides labelled transitions                       //
////////////////////////////////////////////////////////////////////////////////
// Author: Gerald Anleitner                                                   //
// Theme.: 2                                                                  //
// Group.: 5 (Gerald Anleitner, Markus Keidl, Stefan Seltzsam)                //
//                                                                            //
// Date of creation: 14.05.1996        Date of last change: 02.07.1996        //
////////////////////////////////////////////////////////////////////////////////

#ifndef _LABELLED_TRANSITION_HH_
#define _LABELLED_TRANSITION_HH_

#include <transition.hh>
#include <state.hh>
#include <Input_Atom.hh>
#include <Protocol.hh>
#include <Input_Stream.hh>

enum {DEFAULT, POINT, OR};

class Labelled_Transition : public Transition
{
public:
  // constructors and destructors
  Labelled_Transition(const Labelled_Transition&);
  Labelled_Transition(State*, Input_Atom);
  Labelled_Transition(State*, Input_Atom, int);
  Labelled_Transition(Input_Atom);
  Labelled_Transition(Input_Atom, int);
  virtual ~Labelled_Transition();

  // methods
  virtual void set_label(const Input_Atom&);    // set the label of the transition
  virtual Input_Atom get_label() const;         // get the label of the transition
  virtual int get_type();                       // get the type of the transition
  virtual void set_type(int new_type);          // set the type of the transition
  virtual void send(Protocol&);

private:

  // private constructors and destructors
  Labelled_Transition();
  Labelled_Transition(State*);

  // data
  Input_Atom label;
  int type;
};

#endif //_LABELLED_TRANSITION_HH_
