////////////////////////////////////////////////////////////////////////////////
// Filename: transition.hh                                                    //
// Purpose : Definition of class Transition                                   //
//           Abstract baseclass for several types of transitions              //
//           needed for building the AUTOMATON                                //
// BE AWARE: DO NOT CREATE EPSILON CYLES! THE SEND METHOD WILL NOT WORK!      //
////////////////////////////////////////////////////////////////////////////////
// Author: Gerald Anleitner                                                   //
// Theme.: 2                                                                  //
// Group.: 5 (Gerald Anleitner, Markus Keidl, Stefan Seltzsam)                //
//                                                                            //
// Date of creation: 14.05.1996        Date of last change: 28.06.1996        //
////////////////////////////////////////////////////////////////////////////////

#ifndef _TRANSITION_HH_
#define _TRANSITION_HH_

#include "Protocol.hh"
#include <state.hh>

class State;

class Transition
{
public:

  // constructors and destructors
  Transition();
  virtual ~Transition();

  // methods
  virtual void set_label(const Input_Atom&) = 0;               // set the label of the transition
  virtual Input_Atom get_label() const = 0;		       // get the label of the transition
  void set_targetstate(State*);                                // set the targetstate of the transition
  State& get_targetstate() const;			       // get the targetstate of the transition
  virtual int get_type() = 0;                                  // get type of the transition
  virtual void set_type(int new_type) = 0;                     // set type of the transition
  virtual void send(Protocol&) = 0; 

protected:

  // data
  State* targetstate;					       // targetstate of the transition
};

#endif // _TRANSITION_HH_

