////////////////////////////////////////////////////////////////////////////////
// Filename: unlabelled_end_state.hh                                          //
// Purpose : defines the class 'Unlabelled_End_State'                         //
// class for unlabelled end states needed for building up the AUTOMATON       //
////////////////////////////////////////////////////////////////////////////////
// Author: Stefan Seltzsam                                                    //
// Theme.: 2                                                                  //
// Group.: 5 (Gerald Anleitner, Stefan Seltzsam, Markus Keidl)                //
//                                                                            //
// Date of creation: 22.05.1996        Date of last change: 22.05.1996        //
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------

#ifndef __UNLABELLED_END_STATE_HH__
#define __UNLABELLED_END_STATE_HH__

#include <state.hh>
#include <unlabelled_state.hh>
#include <String.h>

//------------------------------------------------------------------------------
// class Unlabelled_End_State
//------------------------------------------------------------------------------

class Unlabelled_End_State : public Unlabelled_State
{

public:

  // constructors & destructor
  Unlabelled_End_State();
  Unlabelled_End_State(const Unlabelled_End_State& rhs);
  Unlabelled_End_State(const String& init_token);
  virtual ~Unlabelled_End_State();

  // forward the Protocol_List to all transitions stored in transition_list
  virtual void send(Protocol& hit);

  // set token to tok
  virtual void set_token(const String& tok);

  // return token of state
  virtual String get_token();
  
private:

  // stores token, which a input_stream has, if he can reach this state
  String token;
  
};

#endif





