////////////////////////////////////////////////////////////////////////////////
// Filename: unlabelled_state.hh                                              //
// Purpose : defines the class 'Unlabelled_State'                             //
// class for unlabelled states needed for building up the AUTOMATON           //
////////////////////////////////////////////////////////////////////////////////
// Author: Stefan Seltzsam                                                    //
// Theme.: 2                                                                  //
// Group.: 5 (Gerald Anleitner, Stefan Seltzsam, Markus Keidl)                //
//                                                                            //
// Date of creation: 22.05.1996        Date of last change: 09.07.1996        //
////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------

#ifndef __UNLABELLED_STATE_HH__
#define __UNLABELLED_STATE_HH__

#include <state.hh>

//------------------------------------------------------------------------------
// class Unlabelled_State
//------------------------------------------------------------------------------

class Unlabelled_State : public State
{

public:

  // constructors & destruktor
  Unlabelled_State();
  Unlabelled_State(const Unlabelled_State& rhs);
  virtual ~Unlabelled_State();

  // add a transition to transition_list
  virtual void add_transition(Transition* trans);

  // remove a transition from transition_list
  virtual void remove_transition(Transition* trans);
  
  // set internal iterator to first transition of transition_list
  virtual void first();

  // set internal iterator to next transition of transition_list  
  virtual void next();

  // delete and clear transition_list
  virtual void clear();

  // get the actual transition, which the internal iterator is pointing at - NULL = End of List
  virtual Transition* operator()() const;

  // forward the Protocol_List to all transitions stored in transition_list
  virtual void send(Protocol& hit);

protected:

  Pix epsilon_loop_detection; // used to detect, if we are in an epsilon cycle

};

#endif

